# SoVRMLNormal Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLNormal.h>`

Inheritance diagram for SoVRMLNormal:

List of all members.

## Detailed Description

The SoVRMLNormal class is used to bind normals to geometry.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      Normal {
        exposedField MFVec3f vector  []   # (-,)
      }

This node defines a set of 3D surface normal vectors to be used in the vector field of some geometry nodes (e.g., SoVRMLIndexedFaceSet and SoVRMLElevationGrid). This node contains one multiple-valued field that contains the normal vectors. Normals shall be of unit length.

## Public Member Functions

| SoVRMLNormal (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoMFVec3f | vector

## Protected Member Functions

virtual | ~SoVRMLNormal ()

## Constructor & Destructor Documentation

SoVRMLNormal::SoVRMLNormal | ( | void |  | ) |

| Constructor.

SoVRMLNormal::~SoVRMLNormal | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLNormal::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoVRMLNormal::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoVRMLNormal::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoVRMLNormal::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoVRMLNormal::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

void SoVRMLNormal::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoNode.

## Member Data Documentation

SoMFVec3f SoVRMLNormal::vector

| The normal vectors. Empty by default.

The documentation for this class was generated from the following files:

- SoVRMLNormal.h
- Normal.cpp